<?php
/**
 * @package    Albireo I
 * @subpackage Core
 * @copyright  Copyright (c) 2009 Albireo Solutions. All rights reserved
 * @license    GNU/AGPL http://www.gnu.org/licenses/agpl.html
 *
 * Albireo is free software! You can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU Affero General Public License for more details.
 */

require_once "autoload.php"; // handle automatic load of classes

Localization::session (); // use localization logics

// Code for Session Cookie workaround
/*if (isset($_POST["PHPSESSID"])) {
    session_id($_POST["PHPSESSID"]);
} elseif (isset($_GET["PHPSESSID"])) {
    session_id($_GET["PHPSESSID"]);
}
session_start();

User::session (); // starts user session
*/
$POST_MAX_SIZE = @ini_get('post_max_size');
$POST_MAX_FILESIZE = @ini_get('upload_max_filesize');
$post_max = ($POST_MAX_SIZE > $POST_MAX_FILESIZE) ? $POST_MAX_FILESIZE : $POST_MAX_SIZE;
if( $post_max > 0 ){
    $unit = strtoupper(substr($post_max, -1));
    $multiplier = ($unit == 'M' ? 1048576 : ($unit == 'K' ? 1024 : ($unit == 'G' ? 1073741824 : 1)));

    if ((int)$_SERVER['CONTENT_LENGTH'] > $multiplier*(int)$post_max && $post_max) {
	header("HTTP/1.1 500 Internal Server Error"); // This will trigger an uploadError event in SWFUpload
	HandleError(_("POST požadavek překročil maximální povolenou velikost."));
	exit(0);
    }
}

// Settings
$src = addslashes ( addslashes ( $_GET [ "dirid" ] ) );
$save_path = $src; // The path were we will save the file (getcwd() may not be reliable and should be tested in your environment)
//$save_path = "./temporary/";
$upload_name = "Filedata";
$max_file_size_in_bytes = 2147483647; // 2GB in bytes

// Other variables
$MAX_FILENAME_LENGTH = 260;
$file_name = "";
$uploadErrors = array(
    0=>_("Nevyskytla se žádná chyba, soubor byl nahrán úspěšně."),
    1=>_("Nahrávaný soubor překročil maximální velikost pro nahrávání danou nastavením serveru."),
    2=>_("Nahrávaný soubor překročil MAX_FILE_SIZE nastavení specifikované HTML formulářem."),
    3=>_("Nahrávaný soubor se podařilo nahrát jen částečně"),
    4=>_("Žádný soubor nebyl nahrán"),
    6=>_("Není dostupná dočasná složka na serveru pro ukládání nahrávaných souborů."));

if ( !isset ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "/" ) {
    HandleError(_( "Nelze nahrávat soubory do kořenového adresáře!" ));
    return;
}

if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
    $url = "/";
    $urlphysicalname = substr ( $src, 0, -1 );
} else {
    $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
    $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
    $urlphysicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
    $urlphysicalname = ( substr ( $urlphysicalname, -1 ) == "/" ) ? substr ( $urlphysicalname, 0, -1 ) : $urlphysicalname;
}

$parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$urlphysicalname';" );

// if folder isn`t defined in database, we don`t allow you to write in
if ( !is_array ( $parent_dir ) ) {
    HandleError(_("Mateřská složka se nenalézá v databázi, proto není možný zápis!"));
    return;
}

// access checking ///////////////////////////////////////////////////////////
/*if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
    HandleError( _( "Nemáte povolen zápis do této složky" ) );
    return;
}*/
//////////////////////////////////////////////////////////////////////////////

$file_name = FileHandler::validateFileName ( $_FILES[$upload_name]["name"] );

if ( $file_name == "root" ) {
    $HandleError( _( "Soubor se nemůže jmenovat root!" ) );
    return;
}

// nobody can upload php files ///////////////////////////////////////////////
if ( !checkFileType ( $file_name ) ) {
    HandleError( _( "Albireo rozpoznalo nahrávaný soubor jako potenciální PHP skript, který by mohl poškodit systém. Náhrání tohoto souboru nebude povoleno" ) );
    return;
}
//////////////////////////////////////////////////////////////////////////////

if ( Database::connection () -> getResult ( "SELECT `physicalname` FROM `drivefilesv2` WHERE `url`='/$src' AND `physicalname`='$file_name';" ) ) {
    HandleError(_( "Soubor tohoto jména už existuje!" ));
    return;
}

// Validate the upload
if (!isset($_FILES[$upload_name])) {
	HandleError( _( "Žádný soubor nebyl nalezen ve \$_FILES pro " ) ." ". $upload_name);
	exit(0);
} else if (isset($_FILES[$upload_name]["error"]) && $_FILES[$upload_name]["error"] != 0) {
	HandleError($uploadErrors[$_FILES[$upload_name]["error"]]);
	exit(0);
} else if (!isset($_FILES[$upload_name]["tmp_name"]) || !@is_uploaded_file($_FILES[$upload_name]["tmp_name"])) {
	HandleError( _( "Nahrávání selhalo při is_uploaded_file testu." ) );
	exit(0);
} else if (!isset($_FILES[$upload_name]['name'])) {
	HandleError( _( "Soubor nemá žádné jméno." ) );
	exit(0);
}

// Validate the file size (Warning: the largest files supported by this code is 2GB)
$file_size = @filesize($_FILES[$upload_name]["tmp_name"]);
if (!$file_size || $file_size > $max_file_size_in_bytes) {
	HandleError( _( "Soubor překročil maxiámlní povolenou velikost." ) );
	exit(0);
}

if ($file_size <= 0) {
	HandleError( _( "Soubor překročil spodní omezení velikosti." ) );
	exit(0);
}

// Process the file
/*
	At this point we are ready to process the valid file. This sample code shows how to save the file. Other tasks
	 could be done such as creating an entry in a database or generating a thumbnail.

	Depending on your server OS and needs you may need to set the Security Permissions on the file after it has
	been saved.
*/
if (!@move_uploaded_file($_FILES[$upload_name]["tmp_name"], $save_path.$file_name)) {
    HandleError(_("Soubor se nepodařilo uložit.").$save_path.$file_name);
} else {
    //if ( !Database::connection () -> query ( "INSERT INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ( '/$src','".$file_name."', ". User::session () -> getId () .", ".User::session () ->getPrimaryGroup().", 'ww0' );" ) ) {
    if ( !Database::connection () -> query ( "INSERT INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ( '/$src','".$file_name."', ".(int)$_GET["sessionid"].", 3, 'ww0' );" ) ) {
	HandleError( _( "Soubor byl nahrán na server, ale nepodařilo se vytvořit záznam v databázi!" ) );
    }
}

exit(0);

/* Handles the error output. This error message will be sent to the uploadSuccess event handler.  The event handler
will have to check for any error messages and react as needed. */
function HandleError($message)
{
    echo '<strong class="warning">'.$message.'</strong>';
}

/*
 * checks file type
 */
function checkFileType ( $physicalname )
{
    $type = substr ( strrchr ( $physicalname, "." ), 1 ); // find type of file
    if ( $type == "" || substr ( $type, 0, 3 ) == "php" || $type == "phtml" ) {
	return false;
    } else {
	return true;
    }
}
?>